// select `Tools`->`Board:`->ESP32 -> ESP32 Dev Module
/*
 * http://www.brettoliver.org.uk/iCuckooClock/iCuckooClock.htm
 Brett v1 add Kenley Time Server details
 * Brett v3 adapt to ESP32WROOM
 * Use ESP32 Dev Module
 
* v1 as Tank Clock 32
* v2 clearout old code
* v3 4 clearout old code
* v7 adj minStep value to get full rotation in 1 hour (60x minstep)
* v8 add step hour button
* v9 code tidyup
* v10 revearsed sensor
* v11 nomal sensor
* v12 add slow setting in setup to sync clock and add fast setting in setup to set hour
* v13 change slow sync to it works repeatedly
   once clock has connected  pressing "fastAdvance" steps the clock forward quickly- pressing "slowAdvance" steps the clock forward slowly
   this is good for setting the cuckoo chime sync position
* v14 modify minute at 30 so it steps 2 mins and none at 31 to ensure the 30min cuckoo chimes OK
* v15 DST press man hour step so clock moves to end stop then next minute the clock will correct and show DST. Add wintertime button
  add Winter button- remember min when pressed- hold clock until minute is repeated or maybe count 60mins
* v16 added winter button- cancel by pressing "start clock" clock will correct next minute
check what happens if time has passed the hour
* v17 add alternate flash WIFI_Fail_LED_PIN and WIFI_OK_LED_PIN when "Wintertime" is pressed
* v18 add end stop LED pin 23
* v21 cleanup

 */

//#include <Adafruit_NeoPixel.h>
#include "WiFi.h"
#include <AccelStepper.h>
#include <MultiStepper.h>
// Define the stepper motor and the pins that is connected to
//AccelStepper stepper1(1, 19, 18);  // (Typeof driver: with 2 pins, STEP, DIR)
//AccelStepper stepper2(1, 17, 16);
#define HALFSTEP 8
#define motorPin1 19  // IN1 on ULN2003 ==> Blue   on 28BYJ-48
#define motorPin2 18  // IN2 on ULN2004 ==> Pink   on 28BYJ-48
#define motorPin3 17  // IN3 on ULN2003 ==> Yellow on 28BYJ-48
#define motorPin4 16  // IN4 on ULN2003 ==> Orange on 28BYJ-48
// NOTE: The sequence 1-3-2-4 is required for proper sequencing of 28BYJ-48
AccelStepper stepper1(HALFSTEP, motorPin1, motorPin3, motorPin2, motorPin4);


MultiStepper steppersControl;  // Create instance of MultiStepper
#include <SoftwareSerial.h>
//#include <JQ6500_Serial.h>
// Create the mp3 module object,chimevolume
//   Arduino Pin 32 is connected to TX of the JQ6500
//   Arduino Pin 33 is connected to one end of a  1k resistor,
//     the other end of the 1k resistor is connected to RX of the JQ6500
//   If your Arduino is 3v3 powered, you can omit the 1k series resistor
//JQ6500_Serial mp3(32, 33);

//long gotoposition[1]; // An array to store the target positions for each stepper motor
long gotoposition[2];  // An array to store the target positions for each stepper motor
int h = 0;             // hours
int hposition = 0;
int m = 0;  // mins
int mposition = 0;
int lockslow = 0;
int lockfast = 0;

int s = 0;  //secs



long minStep = 43;    // was 27
long hourStep = 773;  // was 800

int manhourStep = 21;      // man adjust + 1hour each press of hour test button
int manhourStepvalue = 0;  // value of manhourStep pin

// each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
long minHome = 0;  // just over a full rotation

// each hour step is hourStep long and 12 of them rotate the stepper about 360deg so 13 (give > a full rotation) x hourStep x will give > a full rotation
long hourHome = 0;  //11154; // just over a full rotation

//Chimes

int chimeAlways = 27;  // Turns On Off chime timer
int slowAdvance_Sw = 36;
int fastAdvance_Sw = 39;
int slowAdvance = 1;
int fastAdvance = 1;
int chimevolume = 0;
int chimeFile = 0;
int chimetestup = 0;  // used to test chime when vol + is pressed and let go
int chimetestdn = 0;  // used to test chime when vol - is pressed and let go
int chimestart = 1;   // enables chimes when timer on
int chimeon = 0;
//int chimeReady            = 0; // enabled after home position is reached so hour full 1/4 and chime won't ring until home reached

// NTP settings
int TIMEZONE = 0;  // timezone (GMT = 0, Japan = 9 1 = gmt summertime)

#define NTP_SERVER "uk.pool.ntp.org"  //local time server

#define WIFI_SMARTCONFIG false

#if !WIFI_SMARTCONFIG
// if you do not use smartConfifg, please specify SSID and password here


#define WIFI_SSID "SSID"   // your WiFi's SSID
#define WIFI_PASS "password"  // your WiFi's passwor







#endif
#define End_Stop_LED_Pin 23
#define WIFI_Fail_LED_PIN 4
#define WIFI_Get_LED_PIN 12
#define WIFI_OK_LED_PIN 15
#define Start_Sw 34
#define Summertime_Sw 35
#define Wintertime_Sw 27
int Wintertime = 0;      // value of wintertime switch
int WintertimeLock = 0;  //Holds on wintertime sw
int WinterCount = 0;     //counts to 60mins for wintertime delay
int summertime = 0;
int firstrun = 0;   //blocks start until start button is pressed
int firstrun1 = 0;  //stops hour motor continualy checking after initial run
int start = HIGH;
int endStopminPin = 25;   // was 21
int endStophourPin = 26;  // was 22
//int minVal;// digital read value of hall sensor
//int hourVal;// digital read value of hall sensor



#define MIN1 0
#define MIN10 1
#define HOUR 2



void setup() {

  Serial.begin(115200);
  Serial.println("start");
  pinMode(End_Stop_LED_Pin, OUTPUT);
  pinMode(WIFI_Fail_LED_PIN, OUTPUT);
  pinMode(WIFI_Get_LED_PIN, OUTPUT);
  pinMode(WIFI_OK_LED_PIN, OUTPUT);
  pinMode(Start_Sw, INPUT);
  pinMode(Wintertime_Sw, INPUT_PULLUP);
  pinMode(Summertime_Sw, INPUT);
  pinMode(endStopminPin, INPUT);
  pinMode(endStophourPin, INPUT);

  pinMode(chimeAlways, INPUT_PULLUP);  //used to set chime timer/chime 24/7  (24/7 LOW Timer High)
  pinMode(slowAdvance_Sw, INPUT);
  pinMode(fastAdvance_Sw, INPUT);
  pinMode(manhourStep, INPUT_PULLUP);
  chimevolume = 30;  //was 15
  chimestart = 1;    // set timer ready for startup
  //JQ9500 sound module
  //mp3.begin(9600);
  //mp3.reset();
  //mp3.setVolume(24);
  //mp3.setLoopMode(MP3_LOOP_NONE);
  //stepper1.setMaxSpeed(300.0);  // Set maximum speed value for the stepper
  //stepper2.setMaxSpeed(1000.0);


  // Adding the 3 steppers to the steppersControl instance for multi stepper control
  steppersControl.addStepper(stepper1);
  // steppersControl.addStepper(stepper2);



  digitalWrite(WIFI_Fail_LED_PIN, HIGH);  //Light NTP fail LED at start



  wifiSetup();

  getNTP();

  // If the min hand is already at or near the end stop/home position we move it on to a non home position
  if (digitalRead(endStopminPin) == 0) {
    endstopMin();
  }

  // If the min hand is already at or near the end stop/home position we move it on to a non home position
 // if (digitalRead(endStophourPin) == 1) {
    //endstopHour();
 // }


  delay(1000);

  //Mins hand are now homed ready to set the time

  // endstopHourzero();  // home hour Stepper
  endstopMinZero();  // home minute Stepper




  stepper1.setMaxSpeed(100.0);  // Set maximum speed value for the stepper
                                // stepper2.setMaxSpeed(500.0);
                                // stepper2.setAcceleration(500.0);
  stepper1.setAcceleration(100.0);
  stepper1.setSpeed(100.0);
  digitalWrite(16, LOW);
  digitalWrite(17, LOW);
  digitalWrite(18, LOW);
  digitalWrite(19, LOW);
}

void loop() {

  //###################################
 
  // ##################################
  // Slow step to set position of minute hand
  slowAdvance = digitalRead(slowAdvance_Sw);
  if (slowAdvance == LOW) {
    stepslow();
    //Serial.println("stepslow");
  }


  // Fast step to set position of minute hand
  fastAdvance = digitalRead(fastAdvance_Sw);
  if (fastAdvance == LOW || lockfast == 1) {
    stepfast();
    // Serial.println("stepfast");
  }
  //###################################

 // Light endstop LED
 if (digitalRead(endStopminPin) == 0)
{
   
  // Serial.println("HIGH");
   digitalWrite(End_Stop_LED_Pin, HIGH); 
}

else if (digitalRead(endStopminPin) == 1)
{
 // Serial.println("LOW");
  digitalWrite(End_Stop_LED_Pin, LOW); 
}


  start = digitalRead(Start_Sw);
  if (start == LOW || firstrun == 1) {
    firstrun = 1;
    digitalWrite(WIFI_OK_LED_PIN, LOW);  //Turn off Green LED when start is pressed
    //Serial.println("Start");


    static int prevSec = -1;
    static int prevMin = -1;
    static int prevDay = -1;
    static int prevHour = -1;  // was -1 v22
    int hour;
    struct tm tmtime;

    getLocalTime(&tmtime);



    // rechecks time when start button is pressed to sync winter/summer time
    if (start == LOW) {
      //Cancel winter retard
     // WintertimeLock = 0;
     // WinterCount = 0;
      Serial.println("getntp");
      getNTP();
    }

    //from stepper blocking##############
    s = tmtime.tm_sec;

    m = tmtime.tm_min;

    h = tmtime.tm_hour;

    // reset itself at 08:30:30 to get accurate time

    if (h == 8 && m == 26 && s == 30) {
      if (prevDay > 0 && tmtime.tm_mday != prevDay)  // day of the month - [ 1 to 31 ]
      {
        Serial.print("Previous Day ");
        Serial.println(prevDay);
        getNTP();
        prevDay = tmtime.tm_mday;
        Serial.print("Previous Day ");
        Serial.println(prevDay);
      }
    }

    // m = m + 1;
    if (WintertimeLock == 0) {  // only steps clock each minute if WintertimeLock is 0 (wintertime pressed and counting to 60)
      if ((m == 0) && (s == 0)) {
        endstopMinZero();  // home minute Stepper
        mposition = 0;

        // this position is 0 min so move min had to 0 seconds ########################################################
        // m = 1;
        // Serial.print("m ");
        // Serial.print(m);
        //Serial.println(" ");
      }


      else if ((m == 30) && (s == 0))  // at 30mins mins step 2mins to ensure 30 min cuckoo sounds
      {
        mposition = (m * minStep) + minStep;
      }


      else if ((m == 31) && (s == 0))  // at 31 mins mins minute hand does not step as it stepped twice at 30mins
      {
        //mposition = mposition;
      }


      else {
        //Serial.print("m ");
        // Serial.print(m);
        // Serial.println(" ");
        mposition = m * minStep;
        //Serial.print("mposition ");
        // Serial.println(mposition);
      }
    }

   // if (WintertimeLock == 1) {  // light WIFI Fail & WIFI OK leds to show winter setting in progress
   //   digitalWrite(WIFI_Fail_LED_PIN, HIGH);
   //   digitalWrite(WIFI_OK_LED_PIN, HIGH);
   // }




    // change 24h time to 12h time
    if (h == 0) {
      h = 12;

    }

    else if (h > 12) {
      h = h - 12;
    }










    //#########################


    //Do every second
    if (prevSec != tmtime.tm_sec) {
      //Serial.println("1sec");
      prevSec = tmtime.tm_sec;

       //set wintertime
  Wintertime = digitalRead(Wintertime_Sw);
  if ((Wintertime == LOW || WintertimeLock == 1) && WinterCount < 3600) {
    WintertimeLock = 1;
    WinterCount = WinterCount + 1;
    // Flash WIFI_Fail_LED & WIFI_OK_LED alternatly every sec while wintertime is being set
    if(tmtime.tm_sec % 2 == 0)
    {
    digitalWrite(WIFI_Fail_LED_PIN, HIGH);
    digitalWrite(WIFI_Get_LED_PIN, LOW);
    }


    if (tmtime.tm_sec % 2 == 1)
    {
      digitalWrite(WIFI_Fail_LED_PIN, LOW);
    digitalWrite(WIFI_Get_LED_PIN, HIGH);
    }
   Serial.print("WinterCount= ");
    Serial.println(WinterCount);
    
  }

  else if (WinterCount == 3600) {
    digitalWrite(WIFI_Fail_LED_PIN, LOW);
    digitalWrite(WIFI_Get_LED_PIN, LOW);
    WinterCount = 0;
    WintertimeLock = 0;
    //Serial.print("WinterCount= ");
    //Serial.println(WinterCount);
  }


/*
  else {
    WintertimeLock = 0;
     WinterCount = 0;
    //Serial.print("WinterCount= ");
    //Serial.println(WinterCount);
  }
*/

  //###################################


      manhourStepvalue = digitalRead(manhourStep);
      if (manhourStepvalue == LOW)  //man step 1 hour on to endstop
      {
        // If the min hand is already at or near the end stop/home position we move it on to a non home position
        if (digitalRead(endStopminPin) == 0) {
          stepoffendstop();
          //delay(500);
        }



        advanceendstop();  //move to end stop
      }



      // Chimes ##################################################
      // Set chime timer or chime on 24/7
      // If Chime Timer switch is on (HIGH)
      //Once triggerred chime stays on until deactivated by time set below to deactivate
      // On initial power up time is checked just before every 1/4 to see if chime should be ON
      if (digitalRead(chimeAlways) == HIGH && tmtime.tm_hour >= 6 && tmtime.tm_hour <= 23 && (m == 14 || m == 29 || m == 44 || m == 59) && chimestart == 1)  //Note CET/CEST used to set chime timer/chime 24/7  (24/7 LOW & Timer High)
      {

        chimestart = 0;
        chimeon = 1;

        /*
   Serial.print ("chimeAlways "); 
    Serial.println ("TIMER");
    Serial.print ("Chimestart "); 
    Serial.println (chimestart);
     Serial.print ("Chimeon "); 
    Serial.println (chimeon);
    */
      }

      else if (digitalRead(chimeAlways) == LOW)

      {
        chimeon = 1;
        /*
    Serial.print ("chimeAlways "); 
   Serial.println ("24/7");
    Serial.print ("Chimestart "); 
    Serial.println (chimestart);
     Serial.print ("Chimeon "); 
    Serial.println (chimeon);
    */
      }


      // If Chime Timer switch is ON HIGh but time is out of range. Once de-activasted chime stays off untill time is in range angaim
      if (digitalRead(chimeAlways) == HIGH && tmtime.tm_hour < 6 && tmtime.tm_hour > 23 && m == 1 && chimestart == 0)  //Note CET/CEST used to set chime timer/chime 24/7  (24/7 LOW & Timer High)
      {

        chimestart = 1;
        chimeon = 0;
        /*
   Serial.print ("chimeAlways "); 
    Serial.println ("TIMER OFF ");
    Serial.print ("Chimestart "); 
    Serial.println (chimestart);
     Serial.print ("Chimeon "); 
    Serial.println (chimeon);
    */
      }

      // sound hour chimes and 1/4 hour chimes if chimeon set to 1 from above 2 if statements
      //if (chimeon == 1) {
      //  quarterHourChime();
      //  hourChime();
     // }




      //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      // Change chime volume.
      //Hold vol up or volume down for over a second to increment or decrement volume
      // Plays a test tone when button is released

      //Volume up
      /*
      if (digitalRead(chimevolUp) == LOW) {
        ++chimevolume;
        ++chimevolume;
        ++chimevolume;

        //max chime volume is 30 //30
        if (chimevolume > 30)  // 30
        {
          chimevolume = 30;  //30
        }
        // end max chime vol is 30

        mp3.setVolume(chimevolume);
        chimetestup = 1;
        Serial.print("Chime Volume ");
        Serial.println(chimevolume);
        //  Serial.print ("Chimetestup");
        //   Serial.println (chimetestup);
      }
     */
      // Test tone played on release of volume up button
      /*
      if (chimetestup == 1 && digitalRead(chimevolUp) == HIGH) {

        mp3.playFileByIndexNumber(17);  // plays short test chime to test volume
        chimetestup = 0;
        //Serial.print ("Chimetestup");
        //   Serial.println (chimetestup);
      }
      */

      //Volume down
      /*
      if (digitalRead(chimevolDn) == LOW) {
        --chimevolume;
        --chimevolume;
        --chimevolume;

        //min chime volume is 0
        if (chimevolume < 0) {
          chimevolume = 0;
        }
        //end min chime volume is 0


        mp3.setVolume(chimevolume);
        chimetestdn = 1;

        Serial.print("Chime Volume ");
        Serial.println(chimevolume);
        //   Serial.print ("Chimetestdn");
        //   Serial.println (chimetestdn);
      }
      // Test tone played on release of volume down button
      if (chimetestdn == 1 && digitalRead(chimevolDn) == HIGH) {
        mp3.playFileByIndexNumber(17);  // plays short chime to test volume
        chimetestdn = 0;
        //Serial.print ("Chimetestdn");
        //    Serial.println (chimetestdn);
      }

      */
      // 2min silence end 11/11
     // if (tmtime.tm_mon == 10 & tmtime.tm_mday == 11 & h == 11 & m == 2 & s == 1)  // chime @ 11th Nov 2 mins past 11 to show 2min silence has ended-- note month starts at 0 eg Nov is 10
     // {

      //  mp3.playFileByIndexNumber(15);
     // }


      //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    }




    //Do every minute
    if (prevMin != tmtime.tm_min) {
      //Serial.println("1min");
      prevMin = tmtime.tm_min;
      // Serial.print("S= ");
      //Serial.println(s);
      Serial.print("WinterCount= ");
      Serial.println(WinterCount);


      // Store the target positions in the "gotopostion" array
      stepper1.setMaxSpeed(100.0);  // was 200 Set maximum speed value for the stepper
      stepper1.setAcceleration(100.0);
      stepper1.setSpeed(100.0);
      gotoposition[0] = mposition;  // 800 steps - full rotation with quater-step resolution
                                    //gotoposition[1] = 1800;


      steppersControl.moveTo(gotoposition);  // Calculates the required speed for all motors
      steppersControl.runSpeedToPosition();  // Blocks until all steppers are in position

      //stepper min disableOutputs
      digitalWrite(16, LOW);
      digitalWrite(17, LOW);
      digitalWrite(18, LOW);
      digitalWrite(19, LOW);


      Serial.print("m ");
      Serial.print(m);
      Serial.println(" ");
      Serial.print("mposition ");
      Serial.println(mposition);
      //Serial.print("h ");
      //Serial.print(h);
      //Serial.println(" ");
      //Serial.print("hposition ");
      // Serial.println(hposition);





      // delay(1000);
      //#######################################################################
    }


    //Do every hour

    if (prevHour != tmtime.tm_hour) {
      //Serial.print("1hour= ");
      //Serial.println(hour);

      //Serial.print("prehourold ");
      // Serial.println(prevHour);

      prevHour = tmtime.tm_hour;
      //Serial.print("prehournew ");
      //Serial.println(prevHour);

      if ((h == 1) || (h == 13))  // 12 midday or midnight oclock are endstop position
      {
        // endstopHourzero();  // home hour Stepper
        //firstrun1 = 1;  // makes sure hour motor stops stepping once homed
        //stepper2.setCurrentPosition(0);
        hposition = 0;  // no extra steps required as midday/midnight are at hour endstop
        //stepper2.setCurrentPosition(800);  //reset stepper position
        // hposition = hourStep;
        Serial.println("h=1 ");
        // Serial.println(h);
        // Serial.print("firstrun1 12 oclock ");
        // Serial.println(firstrun1);

      }

      else if ((h == 2) || (h == 14)) {
        // stepper2.setCurrentPosition(0);
        Serial.print("hposition before=");
        Serial.println(hposition);

        hposition = hourStep * 1;
        Serial.print("hposition after ");
        Serial.println(hposition);
      }




      else if (h == 3) {
        Serial.println("h=3 ");

        hposition = hourStep * 2;
        Serial.print("hposition ");
        Serial.println(hposition);
      }

      else if (h == 4) {
        Serial.println("h=4 ");

        hposition = hourStep * 3;
      }

      else if (h == 5) {
        Serial.println("h=5 ");

        hposition = hourStep * 4;
      }

      else if (h == 6) {
        Serial.print("hposition before=");
        Serial.println(hposition);
        Serial.println("h=6 ");

        hposition = hourStep * 5;
        Serial.print("hposition after ");
        Serial.println(hposition);
      }

      else if (h == 7) {
        Serial.println("h=7 ");

        hposition = hourStep * 6;
      }


      else if (h == 8) {
        Serial.println("h=8 ");

        hposition = hourStep * 7;
      }

      else if (h == 9) {
        Serial.println("h=9 ");

        hposition = hourStep * 8;
      }

      else if (h == 10) {
        Serial.println("h=10 ");

        hposition = hourStep * 9;
      }

      else if (h == 11) {
        Serial.println("h=11 ");

        hposition = hourStep * 10;
      }

      else if (h == 12) {
        Serial.println("h=12 ");

        hposition = hourStep * 11;
      }



      if ((h != 1) && (h != 13)) {


        // Store the target positions in the "gotopostion" array

        gotoposition[1] = hposition;
        // gotoposition[1] = hposition + m;



        steppersControl.moveTo(gotoposition);  // Calculates the required speed for all motors/////////////////////////////
        steppersControl.runSpeedToPosition();  // Blocks until all steppers are in position



        //Serial.print("h= ");
        //Serial.print(h);
        //Serial.println(" ");
        Serial.print("hposition  ");
        Serial.println(hposition);
        //Serial.print("firstrun1 hour ");
        // Serial.print(firstrun1);
      }
    }
  }
}  // needs start button pressed to run
//////////////////////////////
// WiFi and NTP section
//////////////////////////////

void getNTP(void) {
  for (int i = 0; WiFi.status() != WL_CONNECTED; i++) {
    if (i > 30) {
      ESP.restart();
    }
    Serial.println("Waiting for WiFi connection..");
    delay(1000);
  }
  // check for sumertime
  summertime = digitalRead(Summertime_Sw);





  if (summertime == HIGH)  // Summertime sw is off
  {
    TIMEZONE = 0;  //Set for GMT
  }


  else if (summertime == LOW)  // Summertime sw is on
  {
    TIMEZONE = 1;  //Set for GMT + 1 ## can be used for testing times other times
  }

  configTime(TIMEZONE * 3600L, 0, NTP_SERVER);
  printLocalTime();
}



void getNTPTest() {  //used to man set hour for clock testing

  TIMEZONE = TIMEZONE + 1;

  Serial.print("Timezone set to ");
  Serial.println(TIMEZONE);
  Serial.println("getntpTest");
  configTime(TIMEZONE * 3600L, 0, NTP_SERVER);
  printLocalTime();
  delay(300);
}

void printLocalTime() {
  struct tm timeinfo;
  if (!getLocalTime(&timeinfo)) {
    Serial.println("Failed to obtain time");
    digitalWrite(WIFI_Fail_LED_PIN, HIGH);
    digitalWrite(WIFI_OK_LED_PIN, LOW);

    return;
  }
  //Serial.println(&timeinfo, "%A, %Y-%m-%d %H:%M:%S");

  Serial.print("hour ");
  Serial.print(&timeinfo, "%H");
  Serial.print(" minute ");
  Serial.print(&timeinfo, "%M");
  Serial.print(" second ");
  Serial.println(&timeinfo, "%S");
  delay(1000);
}


void wifiSetup() {
  WiFi.mode(WIFI_STA);
#if WIFI_SMARTCONFIG
  WiFi.begin();
#else
  WiFi.begin(WIFI_SSID, WIFI_PASS);
#endif

  for (int i = 0;; i++) {
    Serial.println("Connecting to WiFi...");
    //digitalWrite(WIFI_Get_LED_PIN, HIGH);
    digitalWrite(WIFI_OK_LED_PIN, LOW);
    delay(500);
    digitalWrite(WIFI_Get_LED_PIN, HIGH);
    delay(500);
    digitalWrite(WIFI_Get_LED_PIN, LOW);

    if (WiFi.status() == WL_CONNECTED) {
      digitalWrite(WIFI_Fail_LED_PIN, LOW);
      digitalWrite(WIFI_Get_LED_PIN, LOW);
      digitalWrite(WIFI_OK_LED_PIN, HIGH);
      break;
    }
#if WIFI_SMARTCONFIG
    if (i > 30)
      break;
#endif
  }

#if WIFI_SMARTCONFIG
  if (WiFi.status() != WL_CONNECTED) {
    WiFi.mode(WIFI_AP_STA);
    WiFi.beginSmartConfig();

    //Wait for SmartConfig packet from mobile
    Serial.println("Waiting for SmartConfig.");
    while (!WiFi.smartConfigDone()) {
      Serial.print(".");
      //pixels.setPixelColor(0, pixels.Color(0, 255, 0)); // red
      // pixels.show();
      delay(1000);
    }

    Serial.println("");
    Serial.println("SmartConfig received.");

    //Wait for WiFi to connect to AP
    Serial.println("Waiting for WiFi");
    while (WiFi.status() != WL_CONNECTED) {
      delay(1000);
      Serial.print(",");
    }
  }
  Serial.println("WiFi Connected.");
#endif

  Serial.print("SSID: ");
  Serial.println(WiFi.SSID());
  Serial.print("IP Address: ");
  Serial.println(WiFi.localIP());
}
//#########################################################
// steps min away from home
void endstopMin() {             // homes min stepper
  stepper1.setMaxSpeed(100.0);  // was 200 Set maximum speed value for the stepper
  stepper1.setAcceleration(100.0);
  stepper1.setSpeed(100.0);
  Serial.println("Minute homing........");


  //minVal = digitalRead(endStopminPin);
  //Serial.print("minVal ");
  //Serial.println(minVal);
  //delay(2000);
  stepper1.setCurrentPosition(0);  //reset stepper position
  //while (minVal == 1 && minHome <3164)
  while (digitalRead(endStopminPin) == 0 && minHome < 1709640)  //was 1509640 number must be > than a full turn so home position sensor is alway reached
  {
    stepper1.moveTo(minHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper1.run();
    minHome++;

    //minHome = minHome-1; // steps the motor back towards home
    //Serial.println(minHome);
    // Serial.println(minVal);
  }

  //stepper min disableOutputs
  digitalWrite(16, LOW);
  digitalWrite(17, LOW);
  digitalWrite(18, LOW);
  digitalWrite(19, LOW);
  Serial.println(minHome);
  minHome = 0;  // minHome must be reset or minHome count will eventually be > 399640 b4 home is reached
  Serial.println("Minutes stepper now away from home");
  stepper1.setCurrentPosition(0);  //reset stepper position to new home
}


//#########################################################

//#########################################################
// steps min away from home
void stepoffendstop() {         // move min off endstop
  stepper1.setMaxSpeed(300.0);  // was 200 Set maximum speed value for the stepper
  stepper1.setAcceleration(300.0);
  stepper1.setSpeed(300.0);
  Serial.println("Minute homing........");


  //minVal = digitalRead(endStopminPin);
  //Serial.print("minVal ");
  //Serial.println(minVal);
  //delay(2000);
  stepper1.setCurrentPosition(0);  //reset stepper position
  //while (minVal == 1 && minHome <3164)
  while (digitalRead(endStopminPin) == 0 && minHome < 4009640)  //was 399640 number must be > than a full turn so home position sensor is alway reached
  {
    stepper1.moveTo(minHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper1.run();
    minHome++;

    //minHome = minHome-1; // steps the motor back towards home
    //Serial.println(minHome);
    // Serial.println(minVal);
  }

  //stepper min disableOutputs
  digitalWrite(16, LOW);
  digitalWrite(17, LOW);
  digitalWrite(18, LOW);
  digitalWrite(19, LOW);
  Serial.println(minHome);
  minHome = 0;  // minHome must be reset or minHome count will eventually be > 399640 b4 home is reached
  Serial.println("Minutes stepper now away from home");
  stepper1.setCurrentPosition(0);  //reset stepper position to new home
}


//#########################################################



void endstopMinZero() {         // homes min stepper
  stepper1.setMaxSpeed(100.0);  // was 250Set maximum speed value for the stepper
  stepper1.setAcceleration(100.0);
  stepper1.setSpeed(100.0);  //was250
  Serial.println("Minute homing........");


  //minVal = digitalRead(endStopminPin);
  //Serial.print("minVal ");
  //Serial.println(minVal);
  //delay(2000);
  stepper1.setCurrentPosition(0);  //reset stepper position
  //while (minVal == 1 && minHome <3164)
  while (digitalRead(endStopminPin) == 1 && minHome < 4009640)  //1909640 number must be > than a full turn so home position sensor is alway reached
  {
    stepper1.moveTo(minHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper1.run();
    minHome++;

    //minHome = minHome-1; // steps the motor back towards home
  }

  Serial.print("Min zero stepper now home- minHome=");
  Serial.println(minHome);
  //stepper min disableOutputs
  digitalWrite(16, LOW);
  digitalWrite(17, LOW);
  digitalWrite(18, LOW);
  digitalWrite(19, LOW);

  if (minHome == 4009640)  // 3009640 stop clock and flash LED if end stop not found
  {

    Serial.println("Min End Stop Fail ");
    MinEndStopFail();
  }
  Serial.println(minHome);
  minHome = 0;  // minHome must be reset or minHome count will eventually be > 399640 b4 home is reached
  Serial.println("Minutes stepper now home");
  stepper1.setCurrentPosition(0);  //reset stepper position to new home
}

//########################################################


//#########################################################
void advanceendstop() {         // homes min stepper to advance clock 1 hour
  stepper1.setMaxSpeed(300.0);  // was 250Set maximum speed value for the stepper
  stepper1.setAcceleration(100.0);
  stepper1.setSpeed(300.0);  //was250
  Serial.println("Minute homing........");


  //minVal = digitalRead(endStopminPin);
  //Serial.print("minVal ");
  //Serial.println(minVal);
  //delay(2000);
  stepper1.setCurrentPosition(0);  //reset stepper position
  //while (minVal == 1 && minHome <3164)
  while (digitalRead(endStopminPin) == 1 && minHome < 4009640)  //1909640 number must be > than a full turn so home position sensor is alway reached
  {
    stepper1.moveTo(minHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper1.run();
    minHome++;

    //minHome = minHome-1; // steps the motor back towards home
  }

  Serial.print("Min zero stepper now home- minHome=");
  Serial.println(minHome);
  //stepper min disableOutputs
  digitalWrite(16, LOW);
  digitalWrite(17, LOW);
  digitalWrite(18, LOW);
  digitalWrite(19, LOW);

  if (minHome == 4009640)  // 3009640 stop clock and flash LED if end stop not found
  {

    Serial.println("Min End Stop Fail ");
    MinEndStopFail();
  }
  Serial.println(minHome);
  minHome = 0;  // minHome must be reset or minHome count will eventually be > 399640 b4 home is reached
  Serial.println("Minutes stepper now home");
  stepper1.setCurrentPosition(0);  //reset stepper position to new home
}

//########################################################




//#########################################################
void MinRotate() {              // rotateminstepper 1 revolution for testing
  stepper1.setMaxSpeed(100.0);  // was 250Set maximum speed value for the stepper
  stepper1.setAcceleration(100.0);
  stepper1.setSpeed(100.0);  //was250
  Serial.println("Minute rotate........");


  //minVal = digitalRead(endStopminPin);
  //Serial.print("minVal ");
  //Serial.println(minVal);
  //delay(2000);
  stepper1.setCurrentPosition(0);  //reset stepper position
  //while (minVal == 1 && minHome <3164)
  while (digitalRead(endStopminPin) == 0 && minHome < 4009640)  // endstop LED should be on as end stop reached from endstopMinZero() so now step until end stop LED goes out
  {
    stepper1.moveTo(minHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper1.run();
    minHome++;


    //minHome = minHome-1; // steps the motor back towards home
  }

  // Then step on until endstop reached again
  while (digitalRead(endStopminPin) == 1 && minHome < 4009640)  //1909640 number must be > than a full turn so home position sensor is alway reached
  {
    stepper1.moveTo(minHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper1.run();
    minHome++;


    //minHome = minHome-1; // steps the motor back towards home
  }

  Serial.print("Min zero stepper now home- minHome=");
  Serial.println(minHome);
  //stepper hour disableOutputs
  digitalWrite(16, LOW);
  digitalWrite(17, LOW);
  digitalWrite(18, LOW);
  digitalWrite(19, LOW);
  
  if (minHome == 4009640)  // 3009640 stop clock and flash LED if end stop not found
  {

    Serial.println("Min End Stop Fail ");
    MinEndStopFail();
  }
  Serial.println(minHome);
  minHome = 0;  // minHome must be reset or minHome count will eventually be > 399640 b4 home is reached
  Serial.println("Minutes stepper now home");
  stepper1.setCurrentPosition(0);  //reset stepper position to new home
}

//########################################################

//#########################################################
// steps min away from home
void stepslow() {              // move min off endstop
  stepper1.setMaxSpeed(50.0);  // was 200 Set maximum speed value for the stepper
  stepper1.setAcceleration(300.0);
  stepper1.setSpeed(50.0);

  // Serial.println("Minute slow step");


  //minVal = digitalRead(endStopminPin);
  //Serial.print("minVal ");
  //Serial.println(minVal);
  //delay(2000);
  stepper1.setCurrentPosition(0);  //reset stepper position
  //while (minVal == 1 && minHome <3164)
  minHome = 1;
  while (slowAdvance == 0)  //was 399640 number must be > than a full turn so home position sensor is alway reached
  {

    stepper1.moveTo(minHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper1.run();
    minHome++;
    slowAdvance = digitalRead(slowAdvance_Sw);

    //minHome = minHome-1; // steps the motor back towards home
    //Serial.println(minHome);
    // Serial.println(minVal);
  }

  //stepper min disableOutputs
  digitalWrite(16, LOW);
  digitalWrite(17, LOW);
  digitalWrite(18, LOW);
  digitalWrite(19, LOW);
  Serial.println(minHome);
  minHome = 0;  // minHome must be reset or minHome count will eventually be > 399640 b4 home is reached
  //Serial.println("Minutes stepper now away from home");
  stepper1.setCurrentPosition(0);  //reset stepper position to new home
}


//#########################################################

//#########################################################
// steps min away from home
void stepfast() {               // move min off endstop
  stepper1.setMaxSpeed(300.0);  // was 200 Set maximum speed value for the stepper
  stepper1.setAcceleration(300.0);
  stepper1.setSpeed(300.0);

  //Serial.println("Minute  step");


  //minVal = digitalRead(endStopminPin);
  //Serial.print("minVal ");
  //Serial.println(minVal);
  //delay(2000);
  stepper1.setCurrentPosition(0);  //reset stepper position
  //while (minVal == 1 && minHome <3164)
  minHome = 1;
  while (fastAdvance == 0)  //was 399640 number must be > than a full turn so home position sensor is alway reached
  {

    stepper1.moveTo(minHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper1.run();
    minHome++;
    fastAdvance = digitalRead(fastAdvance_Sw);

    //minHome = minHome-1; // steps the motor back towards home
    //Serial.println(minHome);
    // Serial.println(minVal);
  }

  //stepper min disableOutputs
  digitalWrite(16, LOW);
  digitalWrite(17, LOW);
  digitalWrite(18, LOW);
  digitalWrite(19, LOW);
  Serial.println(minHome);
  minHome = 0;  // minHome must be reset or minHome count will eventually be > 399640 b4 home is reached
  //Serial.println("Minutes stepper now away from home");
  stepper1.setCurrentPosition(0);  //reset stepper position to new home
}


//#########################################################



/*
//########################################################

//if endstop aleady active steps until endstop is off
void endstopHour() {
  //stepper2.setMaxSpeed(500.0);  // Set maximum speed value for the stepper
 // stepper2.setAcceleration(500.0);
 // stepper2.setSpeed(300.0);
  Serial.println("Hours moving away from home........");
  //stepper hour enableOutputs
  digitalWrite(sleep2, LOW);


  //stepper2.setCurrentPosition(0);                                 //reset stepper position
  while (digitalRead(endStophourPin) == 0 && hourHome < 2774944)  // number must be > than a full turn so home position sensor is alway reached
  {
   // stepper2.moveTo(hourHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
   // stepper2.run();
    hourHome++;  // steps the motor back towards home
    //Serial.println(hourHome);
  }

  //stepper hour disableOutputs
  digitalWrite(sleep2, HIGH);

  //chimeReady = 1;

  Serial.println("Hour stepper now away from home");
  Serial.println(hourHome);
  hourHome = 0;                    // hourHome must be reset or hourHome count will eventually be > 1274944 b4 home is reached
 // stepper2.setCurrentPosition(0);  //reset stepper position to new home
}
*/

/*
//########################################################
void endstopHourzero() {
  //stepper2.setMaxSpeed(500.0);  // Set maximum speed value for the stepper
 // stepper2.setAcceleration(500.0);
 // stepper2.setSpeed(300.0);
  Serial.println("Hours homing........");
  //stepper hour enableOutputs
  digitalWrite(sleep2, LOW);

 // stepper2.setCurrentPosition(0);                                 //reset stepper position
  while (digitalRead(endStophourPin) == 1 && hourHome < 2774944)  // 2774944 number must be > than a full turn so home position sensor is alway reached
  {
   // stepper2.moveTo(hourHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
   // stepper2.run();
    hourHome++;  // steps the motor back towards home
    //Serial.println(hourHome);
  }


  //stepper hour disableOutputs
  digitalWrite(sleep2, HIGH);

  if (hourHome == 2774944)  // was 2774944 stop clock and flash LED if end stop not found
  {
    HourEndStopFail();
  }

  //chimeReady = 1;

  Serial.print("Hour zero stepper now home- hourHome=");
  Serial.println(hourHome);
  hourHome = 0;
  //Serial.print("hourHome reset to zero=");
  //Serial.println(hourHome);        // hourHome must be reset or hourHome count will eventually be > 1274944 b4 home is reached
  //stepper2.setCurrentPosition(0);  //reset stepper position to new home
}

*/




//================================================================================================================
//
// Function name : quarterhourchime
// called from   : <tasksEverySecond>
//
// Purpose       : chime 1/4 1/2 & 3/4 hours
// Parameters    : none
// Return value  : none
//
//================================================================================================================
//void quarterHourChime() {


  //if ((m == 15 || m == 30 || m == 45) && s == 2)  //ok on 5
 // {
    //load index variable with file index number
    // play selected 1/4 chime through the JQ6500(a IC3)
   // switch (m) {
   //   case 15: mp3.playFileByIndexNumber(13); break;
  //    case 30: mp3.playFileByIndexNumber(14); break;
   //   case 45: mp3.playFileByIndexNumber(15); break;
  //  }
//  }
 // if ((m == 59) && s == 53)  //ok on 5
//  {
    //load index variable with file index number
    // play selected 1/4 chime through the JQ6500(a IC3)
  //  mp3.playFileByIndexNumber(16);
 // }
//}

/*
 if (m == 0 && s == 7 )//was 55
{
 
      mp3.playFileByIndexNumber(16);//at oclock the chime starts after the motor has moved
    
    }
   


}  //end of quarterHourChime

  
*/

//================================================================================================================
//
// Function name : hourChime
// called from   : <tasksEverySecond>
//
// Purpose       : chime hours
// Parameters    : none
// Return value  : none
//
//================================================================================================================
/*
void hourChime() {
  //if its getting near to start of the chime

  //if its time for the chime to start after steeper motor has homed

  if (m == 0 && s == 8)  //was 0
  {
    //calculate filenumber variable to ensure  results 1 - 12
    if (h == 0)  // if midnight  make hours = 24
    {
      chimeFile = 24;
    }

    else {
      chimeFile = h;  //was -1;// convert for GMT
    }

    if (chimeFile > 12) chimeFile = chimeFile - 12;

    // play selected hour chime through the JQ6500(a IC3)
    switch (chimeFile) {
      case 1: mp3.playFileByIndexNumber(1); break;
      case 2: mp3.playFileByIndexNumber(2); break;
      case 3: mp3.playFileByIndexNumber(3); break;
      case 4: mp3.playFileByIndexNumber(4); break;
      case 5: mp3.playFileByIndexNumber(5); break;
      case 6: mp3.playFileByIndexNumber(6); break;
      case 7: mp3.playFileByIndexNumber(7); break;
      case 8: mp3.playFileByIndexNumber(8); break;
      case 9: mp3.playFileByIndexNumber(9); break;
      case 10: mp3.playFileByIndexNumber(10); break;
      case 11: mp3.playFileByIndexNumber(11); break;
      case 12: mp3.playFileByIndexNumber(12); break;
    }
    //chimeReady = 0;
  }
}  //end of <hourChimes> return to <loop>


*/

//#####################################################################################
//void hourChime() {

  //Hour chimes must comple before steeper motors start to home


  //calculate filenumber variable to ensure  results 1 - 12
 // if (h == 0)  // if midnight  make hours = 24
 // {
 //   chimeFile = 24;
 // }

 // else {
  //  chimeFile = h;
 // }

  //if (chimeFile > 12) {
  //  chimeFile = chimeFile - 12;
  //}


  //if (chimeFile == 12 & m == 59 & s == 58)  // chime 1 olcock
  //{

   // mp3.playFileByIndexNumber(1);
  //}

 // else if (chimeFile == 1 & m == 59 & s == 58)  // chime 2 olcock
  //{

  //  mp3.playFileByIndexNumber(2);
  //}

 // else if (chimeFile == 2 & m == 59 & s == 58)  // chime 3 olcock
  //{

  //  mp3.playFileByIndexNumber(3);
  //}

  //else if (chimeFile == 3 & m == 59 & s == 58)  // chime 4 olcock
  //{

  //  mp3.playFileByIndexNumber(4);
 // }


 // else if (chimeFile == 4 & m == 59 & s == 58)  // chime 5 olcock
 // {

 //   mp3.playFileByIndexNumber(5);
 // }


 // else if (chimeFile == 5 & m == 59 & s == 58)  // chime 6 olcock
 // {

  //  mp3.playFileByIndexNumber(6);
 // }


 // else if (chimeFile == 6 & m == 59 & s == 58)  // chime 7 olcock
 // {

  //  mp3.playFileByIndexNumber(7);
 // }

 // else if (chimeFile == 7 & m == 59 & s == 58)  // chime 8 olcock
 // {

 //   mp3.playFileByIndexNumber(8);
  //}

 // else if (chimeFile == 8 & m == 59 & s == 58)  // chime 9 olcock
 // {

  //  mp3.playFileByIndexNumber(9);
 // }


 // else if (chimeFile == 9 & m == 59 & s == 58)  // chime 10 olcock
 // {

 //   mp3.playFileByIndexNumber(10);
 // }


 // else if (chimeFile == 10 & m == 59 & s == 58)  // chime 11 olcock
 // {

  //  mp3.playFileByIndexNumber(11);
 // }

  //else if (chimeFile == 11 & m == 59 & s == 58)  // chime 12 olcock
  //{

   // mp3.playFileByIndexNumber(12);
 // }
//}




// if minute end stop not found then clock stops and LED WIFI fail flshes
void MinEndStopFail() {
  digitalWrite(WIFI_Fail_LED_PIN, HIGH);
  delay(500);
  digitalWrite(WIFI_Fail_LED_PIN, LOW);
  delay(500);
  MinEndStopFail();
}


// if minute end stop not found then clock stops and LED WIFI GET flashes
void HourEndStopFail() {
  digitalWrite(WIFI_Get_LED_PIN, HIGH);
  delay(500);
  digitalWrite(WIFI_Get_LED_PIN, LOW);
  delay(500);
  HourEndStopFail();
}
